diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/antenna/test/test-angles.cc ns-3.40/src/antenna/test/test-angles.cc
--- ns-3.39/src/antenna/test/test-angles.cc	2023-07-05 14:23:47.673426900 -0700
+++ ns-3.40/src/antenna/test/test-angles.cc	2023-09-27 13:30:37.610839000 -0700
@@ -134,6 +134,156 @@
     NS_TEST_EXPECT_MSG_EQ_TOL(a.GetInclination(), m_a.GetInclination(), 1e-10, "incorrect theta");
 }
 
+using WrapToRangeFunction = std::function<double(double)>;
+
+/**
+ * \ingroup tests
+ *
+ * \brief  Test bounds for various WrapTo... methods (WrapTo180, WrapTo360, WrapToPi, and WrapTo2Pi)
+ * by using a std::function wrapper
+ */
+class WrapToRangeTestCase : public TestCase
+{
+  public:
+    /**
+     * Build the test name
+     * \param lowerBound the lower bound of the WrapTo... function
+     * \param upperBound the upper bound of the WrapTo... function
+     * \return the test name
+     */
+    static std::string BuildNameString(double lowerBound, double upperBound);
+    /**
+     * Constructor
+     * \param wrapper for one of WrapTo180, WrapTo360, WrapToPi, and WrapTo2Pi
+     * \param lowerBound the corresponding lower bound
+     * \param upperBound the corresponding upper bound
+     */
+    WrapToRangeTestCase(WrapToRangeFunction wrapper, double lowerBound, double upperBound);
+
+  protected:
+    /**
+     * The given wrapper shall wrap an angle into the expected range
+     * \param wrapPoint an angle
+     */
+    void CheckWrappingPoint(double wrapPoint);
+
+  private:
+    void DoRun() override;
+
+    WrapToRangeFunction m_wrapper; //!< the wrapper function
+    double m_lowerBound;           //!< the corresponding lower bound
+    double m_upperBound;           //!< the corresponding upper bound
+};
+
+std::string
+WrapToRangeTestCase::BuildNameString(double lowerBound, double upperBound)
+{
+    std::ostringstream oss;
+    oss << "WrapTo [" << lowerBound << ", " << upperBound << ")";
+    return oss.str();
+}
+
+WrapToRangeTestCase::WrapToRangeTestCase(WrapToRangeFunction wrapper,
+                                         double lowerBound,
+                                         double upperBound)
+    : TestCase(BuildNameString(lowerBound, upperBound)),
+      m_wrapper(wrapper),
+      m_lowerBound(lowerBound),
+      m_upperBound(upperBound)
+{
+}
+
+void
+WrapToRangeTestCase::DoRun()
+{
+    CheckWrappingPoint(m_lowerBound);
+    CheckWrappingPoint(m_upperBound);
+}
+
+void
+WrapToRangeTestCase::CheckWrappingPoint(double wrapPoint)
+{
+    constexpr int STEP_NUM = 100;
+    double directions[] = {std::numeric_limits<double>::lowest(),
+                           std::numeric_limits<double>::max()};
+    for (double dir : directions)
+    {
+        int i = 0;
+        for (double x = wrapPoint; i < STEP_NUM; x = std::nextafter(x, dir), ++i)
+        {
+            // If asserts are enabled, this test will crash with an assert instead of failing
+            double result = m_wrapper(x);
+            NS_TEST_EXPECT_MSG_EQ((m_lowerBound <= result),
+                                  true,
+                                  "Invalid wrap (too low) " << x << " maps to " << result << " and "
+                                                            << result - m_lowerBound);
+            NS_TEST_EXPECT_MSG_EQ((result < m_upperBound),
+                                  true,
+                                  "Invalid wrap (too high) " << x << " maps to " << result
+                                                             << " and " << result - m_lowerBound);
+        }
+    }
+}
+
+/**
+ * \ingroup tests
+ *
+ * \brief Test the output for WrapToRangeFunction
+ */
+class WrapToRangeFunctionalTestCase : public TestCase
+{
+  public:
+    /**
+     * Build the test name
+     * \param angle the angle
+     * \param wrappedAngle the expected result
+     * \return the test name
+     */
+    static std::string BuildNameString(double angle, double wrappedAngle);
+    /**
+     * Constructor
+     * \param wrapper one WrapToRangeFunction
+     * \param angle the angle
+     * \param wrappedAngle the expected result
+     */
+    WrapToRangeFunctionalTestCase(WrapToRangeFunction wrapper, double angle, double wrappedAngle);
+
+  private:
+    void DoRun() override;
+
+    WrapToRangeFunction m_wrapper; //!< the wrapper function
+    double m_angle;                //!< the input angle
+    double m_wrappedAngle;         //!< the expected wrapper angle
+};
+
+std::string
+WrapToRangeFunctionalTestCase::BuildNameString(double angle, double wrappedAngle)
+{
+    std::ostringstream oss;
+    oss << "Wrap " << angle << " to " << wrappedAngle;
+    return oss.str();
+}
+
+WrapToRangeFunctionalTestCase::WrapToRangeFunctionalTestCase(WrapToRangeFunction wrapper,
+                                                             double angle,
+                                                             double wrappedAngle)
+    : TestCase(BuildNameString(angle, wrappedAngle)),
+      m_wrapper(wrapper),
+      m_angle(angle),
+      m_wrappedAngle(wrappedAngle)
+{
+}
+
+void
+WrapToRangeFunctionalTestCase::DoRun()
+{
+    NS_TEST_EXPECT_MSG_EQ_TOL(m_wrapper(m_angle),
+                              m_wrappedAngle,
+                              1e-6,
+                              "Invalid wrap " << m_angle << " wrapped to " << m_wrapper(m_angle)
+                                              << " instead of " << m_wrappedAngle);
+}
+
 /**
  * \ingroup tests
  *
@@ -355,6 +505,18 @@
                                                   Vector(-0.5, 12.45, -1),
                                                   Angles(-M_PI_4, M_PI_4)),
                 TestCase::QUICK);
+    AddTestCase(new WrapToRangeTestCase(WrapTo180, -180, 180), TestCase::QUICK);
+    AddTestCase(new WrapToRangeTestCase(WrapToPi, -M_PI, M_PI), TestCase::QUICK);
+    AddTestCase(new WrapToRangeTestCase(WrapTo360, 0, 360), TestCase::QUICK);
+    AddTestCase(new WrapToRangeTestCase(WrapTo2Pi, 0, 2 * M_PI), TestCase::QUICK);
+    AddTestCase(new WrapToRangeFunctionalTestCase(WrapTo180, -182.2, 177.8), TestCase::QUICK);
+    AddTestCase(new WrapToRangeFunctionalTestCase(WrapTo180, -179, -179), TestCase::QUICK);
+    AddTestCase(new WrapToRangeFunctionalTestCase(WrapTo180, 181, -179), TestCase::QUICK);
+    AddTestCase(new WrapToRangeFunctionalTestCase(WrapTo180, 360.6, 0.6), TestCase::QUICK);
+    AddTestCase(new WrapToRangeFunctionalTestCase(WrapTo360, -182.8, 177.2), TestCase::QUICK);
+    AddTestCase(new WrapToRangeFunctionalTestCase(WrapTo360, -179, 181), TestCase::QUICK);
+    AddTestCase(new WrapToRangeFunctionalTestCase(WrapTo360, 181, 181), TestCase::QUICK);
+    AddTestCase(new WrapToRangeFunctionalTestCase(WrapTo360, 360.2, 0.2), TestCase::QUICK);
 }
 
 /// Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/aodv/helper/aodv-helper.cc ns-3.40/src/aodv/helper/aodv-helper.cc
--- ns-3.39/src/aodv/helper/aodv-helper.cc	2023-07-05 14:23:47.673426900 -0700
+++ ns-3.40/src/aodv/helper/aodv-helper.cc	2023-09-27 13:30:37.610839000 -0700
@@ -59,7 +59,7 @@
 {
     int64_t currentStream = stream;
     Ptr<Node> node;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         node = (*i);
         Ptr<Ipv4> ipv4 = node->GetObject<Ipv4>();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/aodv/model/aodv-id-cache.cc ns-3.40/src/aodv/model/aodv-id-cache.cc
--- ns-3.39/src/aodv/model/aodv-id-cache.cc	2023-07-05 14:23:47.673426900 -0700
+++ ns-3.40/src/aodv/model/aodv-id-cache.cc	2023-09-27 13:30:37.610839000 -0700
@@ -36,7 +36,7 @@
 IdCache::IsDuplicate(Ipv4Address addr, uint32_t id)
 {
     Purge();
-    for (std::vector<UniqueId>::const_iterator i = m_idCache.begin(); i != m_idCache.end(); ++i)
+    for (auto i = m_idCache.begin(); i != m_idCache.end(); ++i)
     {
         if (i->m_context == addr && i->m_id == id)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/aodv/model/aodv-neighbor.cc ns-3.40/src/aodv/model/aodv-neighbor.cc
--- ns-3.39/src/aodv/model/aodv-neighbor.cc	2023-07-05 14:23:47.673426900 -0700
+++ ns-3.40/src/aodv/model/aodv-neighbor.cc	2023-09-27 13:30:37.610839000 -0700
@@ -51,7 +51,7 @@
 Neighbors::IsNeighbor(Ipv4Address addr)
 {
     Purge();
-    for (std::vector<Neighbor>::const_iterator i = m_nb.begin(); i != m_nb.end(); ++i)
+    for (auto i = m_nb.begin(); i != m_nb.end(); ++i)
     {
         if (i->m_neighborAddress == addr)
         {
@@ -65,7 +65,7 @@
 Neighbors::GetExpireTime(Ipv4Address addr)
 {
     Purge();
-    for (std::vector<Neighbor>::const_iterator i = m_nb.begin(); i != m_nb.end(); ++i)
+    for (auto i = m_nb.begin(); i != m_nb.end(); ++i)
     {
         if (i->m_neighborAddress == addr)
         {
@@ -78,7 +78,7 @@
 void
 Neighbors::Update(Ipv4Address addr, Time expire)
 {
-    for (std::vector<Neighbor>::iterator i = m_nb.begin(); i != m_nb.end(); ++i)
+    for (auto i = m_nb.begin(); i != m_nb.end(); ++i)
     {
         if (i->m_neighborAddress == addr)
         {
@@ -125,7 +125,7 @@
     CloseNeighbor pred;
     if (!m_handleLinkFailure.IsNull())
     {
-        for (std::vector<Neighbor>::iterator j = m_nb.begin(); j != m_nb.end(); ++j)
+        for (auto j = m_nb.begin(); j != m_nb.end(); ++j)
         {
             if (pred(*j))
             {
@@ -162,7 +162,7 @@
 Neighbors::LookupMacAddress(Ipv4Address addr)
 {
     Mac48Address hwaddr;
-    for (std::vector<Ptr<ArpCache>>::const_iterator i = m_arp.begin(); i != m_arp.end(); ++i)
+    for (auto i = m_arp.begin(); i != m_arp.end(); ++i)
     {
         ArpCache::Entry* entry = (*i)->Lookup(addr);
         if (entry != nullptr && (entry->IsAlive() || entry->IsPermanent()) && !entry->IsExpired())
@@ -179,7 +179,7 @@
 {
     Mac48Address addr = hdr.GetAddr1();
 
-    for (std::vector<Neighbor>::iterator i = m_nb.begin(); i != m_nb.end(); ++i)
+    for (auto i = m_nb.begin(); i != m_nb.end(); ++i)
     {
         if (i->m_hardwareAddress == addr)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/aodv/model/aodv-packet.cc ns-3.40/src/aodv/model/aodv-packet.cc
--- ns-3.39/src/aodv/model/aodv-packet.cc	2023-07-05 14:23:47.673426900 -0700
+++ ns-3.40/src/aodv/model/aodv-packet.cc	2023-09-27 13:30:37.610839000 -0700
@@ -554,8 +554,7 @@
     i.WriteU8(m_flag);
     i.WriteU8(m_reserved);
     i.WriteU8(GetDestCount());
-    std::map<Ipv4Address, uint32_t>::const_iterator j;
-    for (j = m_unreachableDstSeqNo.begin(); j != m_unreachableDstSeqNo.end(); ++j)
+    for (auto j = m_unreachableDstSeqNo.begin(); j != m_unreachableDstSeqNo.end(); ++j)
     {
         WriteTo(i, (*j).first);
         i.WriteHtonU32((*j).second);
@@ -588,8 +587,7 @@
 RerrHeader::Print(std::ostream& os) const
 {
     os << "Unreachable destination (ipv4 address, seq. number):";
-    std::map<Ipv4Address, uint32_t>::const_iterator j;
-    for (j = m_unreachableDstSeqNo.begin(); j != m_unreachableDstSeqNo.end(); ++j)
+    for (auto j = m_unreachableDstSeqNo.begin(); j != m_unreachableDstSeqNo.end(); ++j)
     {
         os << (*j).first << ", " << (*j).second;
     }
@@ -635,7 +633,7 @@
     {
         return false;
     }
-    std::map<Ipv4Address, uint32_t>::iterator i = m_unreachableDstSeqNo.begin();
+    auto i = m_unreachableDstSeqNo.begin();
     un = *i;
     m_unreachableDstSeqNo.erase(i);
     return true;
@@ -657,8 +655,8 @@
         return false;
     }
 
-    std::map<Ipv4Address, uint32_t>::const_iterator j = m_unreachableDstSeqNo.begin();
-    std::map<Ipv4Address, uint32_t>::const_iterator k = o.m_unreachableDstSeqNo.begin();
+    auto j = m_unreachableDstSeqNo.begin();
+    auto k = o.m_unreachableDstSeqNo.begin();
     for (uint8_t i = 0; i < GetDestCount(); ++i)
     {
         if ((j->first != k->first) || (j->second != k->second))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/aodv/model/aodv-routing-protocol.cc ns-3.40/src/aodv/model/aodv-routing-protocol.cc
--- ns-3.39/src/aodv/model/aodv-routing-protocol.cc	2023-07-05 14:23:47.673426900 -0700
+++ ns-3.40/src/aodv/model/aodv-routing-protocol.cc	2023-09-27 13:30:37.614839000 -0700
@@ -362,15 +362,12 @@
 RoutingProtocol::DoDispose()
 {
     m_ipv4 = nullptr;
-    for (std::map<Ptr<Socket>, Ipv4InterfaceAddress>::iterator iter = m_socketAddresses.begin();
-         iter != m_socketAddresses.end();
-         iter++)
+    for (auto iter = m_socketAddresses.begin(); iter != m_socketAddresses.end(); iter++)
     {
         iter->first->Close();
     }
     m_socketAddresses.clear();
-    for (std::map<Ptr<Socket>, Ipv4InterfaceAddress>::iterator iter =
-             m_socketSubnetBroadcastAddresses.begin();
+    for (auto iter = m_socketSubnetBroadcastAddresses.begin();
          iter != m_socketSubnetBroadcastAddresses.end();
          iter++)
     {
@@ -541,9 +538,7 @@
     }
 
     // Broadcast local delivery/forwarding
-    for (std::map<Ptr<Socket>, Ipv4InterfaceAddress>::const_iterator j = m_socketAddresses.begin();
-         j != m_socketAddresses.end();
-         ++j)
+    for (auto j = m_socketAddresses.begin(); j != m_socketAddresses.end(); ++j)
     {
         Ipv4InterfaceAddress iface = j->second;
         if (m_ipv4->GetInterfaceForAddress(iface.GetLocal()) == iif)
@@ -984,9 +979,7 @@
 RoutingProtocol::IsMyOwnAddress(Ipv4Address src)
 {
     NS_LOG_FUNCTION(this << src);
-    for (std::map<Ptr<Socket>, Ipv4InterfaceAddress>::const_iterator j = m_socketAddresses.begin();
-         j != m_socketAddresses.end();
-         ++j)
+    for (auto j = m_socketAddresses.begin(); j != m_socketAddresses.end(); ++j)
     {
         Ipv4InterfaceAddress iface = j->second;
         if (src == iface.GetLocal())
@@ -1020,7 +1013,7 @@
     // If RouteOutput() caller specified an outgoing interface, that
     // further constrains the selection of source address
     //
-    std::map<Ptr<Socket>, Ipv4InterfaceAddress>::const_iterator j = m_socketAddresses.begin();
+    auto j = m_socketAddresses.begin();
     if (oif)
     {
         // Iterate to find an address on the oif device
@@ -1136,9 +1129,7 @@
     rreqHeader.SetId(m_requestId);
 
     // Send RREQ as subnet directed broadcast from each interface used by aodv
-    for (std::map<Ptr<Socket>, Ipv4InterfaceAddress>::const_iterator j = m_socketAddresses.begin();
-         j != m_socketAddresses.end();
-         ++j)
+    for (auto j = m_socketAddresses.begin(); j != m_socketAddresses.end(); ++j)
     {
         Ptr<Socket> socket = j->first;
         Ipv4InterfaceAddress iface = j->second;
@@ -1505,9 +1496,7 @@
         return;
     }
 
-    for (std::map<Ptr<Socket>, Ipv4InterfaceAddress>::const_iterator j = m_socketAddresses.begin();
-         j != m_socketAddresses.end();
-         ++j)
+    for (auto j = m_socketAddresses.begin(); j != m_socketAddresses.end(); ++j)
     {
         Ptr<Socket> socket = j->first;
         Ipv4InterfaceAddress iface = j->second;
@@ -1868,9 +1857,7 @@
     std::pair<Ipv4Address, uint32_t> un;
     while (rerrHeader.RemoveUnDestination(un))
     {
-        for (std::map<Ipv4Address, uint32_t>::const_iterator i = dstWithNextHopSrc.begin();
-             i != dstWithNextHopSrc.end();
-             ++i)
+        for (auto i = dstWithNextHopSrc.begin(); i != dstWithNextHopSrc.end(); ++i)
         {
             if (i->first == un.first)
             {
@@ -1880,8 +1867,7 @@
     }
 
     std::vector<Ipv4Address> precursors;
-    for (std::map<Ipv4Address, uint32_t>::const_iterator i = unreachable.begin();
-         i != unreachable.end();)
+    for (auto i = unreachable.begin(); i != unreachable.end();)
     {
         if (!rerrHeader.AddUnDestination(i->first, i->second))
         {
@@ -2013,9 +1999,7 @@
      *   Hop Count                      0
      *   Lifetime                       AllowedHelloLoss * HelloInterval
      */
-    for (std::map<Ptr<Socket>, Ipv4InterfaceAddress>::const_iterator j = m_socketAddresses.begin();
-         j != m_socketAddresses.end();
-         ++j)
+    for (auto j = m_socketAddresses.begin(); j != m_socketAddresses.end(); ++j)
     {
         Ptr<Socket> socket = j->first;
         Ipv4InterfaceAddress iface = j->second;
@@ -2087,8 +2071,7 @@
     toNextHop.GetPrecursors(precursors);
     rerrHeader.AddUnDestination(nextHop, toNextHop.GetSeqNo());
     m_routingTable.GetListOfDestinationWithNextHop(nextHop, unreachable);
-    for (std::map<Ipv4Address, uint32_t>::const_iterator i = unreachable.begin();
-         i != unreachable.end();)
+    for (auto i = unreachable.begin(); i != unreachable.end();)
     {
         if (!rerrHeader.AddUnDestination(i->first, i->second))
         {
@@ -2161,10 +2144,7 @@
     }
     else
     {
-        for (std::map<Ptr<Socket>, Ipv4InterfaceAddress>::const_iterator i =
-                 m_socketAddresses.begin();
-             i != m_socketAddresses.end();
-             ++i)
+        for (auto i = m_socketAddresses.begin(); i != m_socketAddresses.end(); ++i)
         {
             Ptr<Socket> socket = i->first;
             Ipv4InterfaceAddress iface = i->second;
@@ -2232,8 +2212,7 @@
     //  route
     std::vector<Ipv4InterfaceAddress> ifaces;
     RoutingTableEntry toPrecursor;
-    for (std::vector<Ipv4Address>::const_iterator i = precursors.begin(); i != precursors.end();
-         ++i)
+    for (auto i = precursors.begin(); i != precursors.end(); ++i)
     {
         if (m_routingTable.LookupValidRoute(*i, toPrecursor) &&
             std::find(ifaces.begin(), ifaces.end(), toPrecursor.GetInterface()) == ifaces.end())
@@ -2242,8 +2221,7 @@
         }
     }
 
-    for (std::vector<Ipv4InterfaceAddress>::const_iterator i = ifaces.begin(); i != ifaces.end();
-         ++i)
+    for (auto i = ifaces.begin(); i != ifaces.end(); ++i)
     {
         Ptr<Socket> socket = FindSocketWithInterfaceAddress(*i);
         NS_ASSERT(socket);
@@ -2273,9 +2251,7 @@
 RoutingProtocol::FindSocketWithInterfaceAddress(Ipv4InterfaceAddress addr) const
 {
     NS_LOG_FUNCTION(this << addr);
-    for (std::map<Ptr<Socket>, Ipv4InterfaceAddress>::const_iterator j = m_socketAddresses.begin();
-         j != m_socketAddresses.end();
-         ++j)
+    for (auto j = m_socketAddresses.begin(); j != m_socketAddresses.end(); ++j)
     {
         Ptr<Socket> socket = j->first;
         Ipv4InterfaceAddress iface = j->second;
@@ -2292,8 +2268,7 @@
 RoutingProtocol::FindSubnetBroadcastSocketWithInterfaceAddress(Ipv4InterfaceAddress addr) const
 {
     NS_LOG_FUNCTION(this << addr);
-    for (std::map<Ptr<Socket>, Ipv4InterfaceAddress>::const_iterator j =
-             m_socketSubnetBroadcastAddresses.begin();
+    for (auto j = m_socketSubnetBroadcastAddresses.begin();
          j != m_socketSubnetBroadcastAddresses.end();
          ++j)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/aodv/model/aodv-rqueue.cc ns-3.40/src/aodv/model/aodv-rqueue.cc
--- ns-3.39/src/aodv/model/aodv-rqueue.cc	2023-07-05 14:23:47.673426900 -0700
+++ ns-3.40/src/aodv/model/aodv-rqueue.cc	2023-09-27 13:30:37.614839000 -0700
@@ -51,7 +51,7 @@
 RequestQueue::Enqueue(QueueEntry& entry)
 {
     Purge();
-    for (std::vector<QueueEntry>::const_iterator i = m_queue.begin(); i != m_queue.end(); ++i)
+    for (auto i = m_queue.begin(); i != m_queue.end(); ++i)
     {
         if ((i->GetPacket()->GetUid() == entry.GetPacket()->GetUid()) &&
             (i->GetIpv4Header().GetDestination() == entry.GetIpv4Header().GetDestination()))
@@ -74,7 +74,7 @@
 {
     NS_LOG_FUNCTION(this << dst);
     Purge();
-    for (std::vector<QueueEntry>::iterator i = m_queue.begin(); i != m_queue.end(); ++i)
+    for (auto i = m_queue.begin(); i != m_queue.end(); ++i)
     {
         if (i->GetIpv4Header().GetDestination() == dst)
         {
@@ -91,7 +91,7 @@
 RequestQueue::Dequeue(Ipv4Address dst, QueueEntry& entry)
 {
     Purge();
-    for (std::vector<QueueEntry>::iterator i = m_queue.begin(); i != m_queue.end(); ++i)
+    for (auto i = m_queue.begin(); i != m_queue.end(); ++i)
     {
         if (i->GetIpv4Header().GetDestination() == dst)
         {
@@ -106,7 +106,7 @@
 bool
 RequestQueue::Find(Ipv4Address dst)
 {
-    for (std::vector<QueueEntry>::const_iterator i = m_queue.begin(); i != m_queue.end(); ++i)
+    for (auto i = m_queue.begin(); i != m_queue.end(); ++i)
     {
         if (i->GetIpv4Header().GetDestination() == dst)
         {
@@ -138,7 +138,7 @@
 RequestQueue::Purge()
 {
     IsExpired pred;
-    for (std::vector<QueueEntry>::iterator i = m_queue.begin(); i != m_queue.end(); ++i)
+    for (auto i = m_queue.begin(); i != m_queue.end(); ++i)
     {
         if (pred(*i))
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/aodv/model/aodv-rtable.cc ns-3.40/src/aodv/model/aodv-rtable.cc
--- ns-3.39/src/aodv/model/aodv-rtable.cc	2023-07-05 14:23:47.673426900 -0700
+++ ns-3.40/src/aodv/model/aodv-rtable.cc	2023-09-27 13:30:37.614839000 -0700
@@ -94,9 +94,7 @@
 RoutingTableEntry::LookupPrecursor(Ipv4Address id)
 {
     NS_LOG_FUNCTION(this << id);
-    for (std::vector<Ipv4Address>::const_iterator i = m_precursorList.begin();
-         i != m_precursorList.end();
-         ++i)
+    for (auto i = m_precursorList.begin(); i != m_precursorList.end(); ++i)
     {
         if (*i == id)
         {
@@ -112,8 +110,7 @@
 RoutingTableEntry::DeletePrecursor(Ipv4Address id)
 {
     NS_LOG_FUNCTION(this << id);
-    std::vector<Ipv4Address>::iterator i =
-        std::remove(m_precursorList.begin(), m_precursorList.end(), id);
+    auto i = std::remove(m_precursorList.begin(), m_precursorList.end(), id);
     if (i == m_precursorList.end())
     {
         NS_LOG_LOGIC("Precursor " << id << " not found");
@@ -148,16 +145,15 @@
     {
         return;
     }
-    for (std::vector<Ipv4Address>::const_iterator i = m_precursorList.begin();
-         i != m_precursorList.end();
-         ++i)
+    for (auto i = m_precursorList.begin(); i != m_precursorList.end(); ++i)
     {
         bool result = true;
-        for (std::vector<Ipv4Address>::const_iterator j = prec.begin(); j != prec.end(); ++j)
+        for (auto j = prec.begin(); j != prec.end(); ++j)
         {
             if (*j == *i)
             {
                 result = false;
+                break;
             }
         }
         if (result)
@@ -243,7 +239,7 @@
         NS_LOG_LOGIC("Route to " << id << " not found; m_ipv4AddressEntry is empty");
         return false;
     }
-    std::map<Ipv4Address, RoutingTableEntry>::const_iterator i = m_ipv4AddressEntry.find(id);
+    auto i = m_ipv4AddressEntry.find(id);
     if (i == m_ipv4AddressEntry.end())
     {
         NS_LOG_LOGIC("Route to " << id << " not found");
@@ -291,8 +287,7 @@
     {
         rt.SetRreqCnt(0);
     }
-    std::pair<std::map<Ipv4Address, RoutingTableEntry>::iterator, bool> result =
-        m_ipv4AddressEntry.insert(std::make_pair(rt.GetDestination(), rt));
+    auto result = m_ipv4AddressEntry.insert(std::make_pair(rt.GetDestination(), rt));
     return result.second;
 }
 
@@ -300,8 +295,7 @@
 RoutingTable::Update(RoutingTableEntry& rt)
 {
     NS_LOG_FUNCTION(this);
-    std::map<Ipv4Address, RoutingTableEntry>::iterator i =
-        m_ipv4AddressEntry.find(rt.GetDestination());
+    auto i = m_ipv4AddressEntry.find(rt.GetDestination());
     if (i == m_ipv4AddressEntry.end())
     {
         NS_LOG_LOGIC("Route update to " << rt.GetDestination() << " fails; not found");
@@ -320,7 +314,7 @@
 RoutingTable::SetEntryState(Ipv4Address id, RouteFlags state)
 {
     NS_LOG_FUNCTION(this);
-    std::map<Ipv4Address, RoutingTableEntry>::iterator i = m_ipv4AddressEntry.find(id);
+    auto i = m_ipv4AddressEntry.find(id);
     if (i == m_ipv4AddressEntry.end())
     {
         NS_LOG_LOGIC("Route set entry state to " << id << " fails; not found");
@@ -339,9 +333,7 @@
     NS_LOG_FUNCTION(this);
     Purge();
     unreachable.clear();
-    for (std::map<Ipv4Address, RoutingTableEntry>::const_iterator i = m_ipv4AddressEntry.begin();
-         i != m_ipv4AddressEntry.end();
-         ++i)
+    for (auto i = m_ipv4AddressEntry.begin(); i != m_ipv4AddressEntry.end(); ++i)
     {
         if (i->second.GetNextHop() == nextHop)
         {
@@ -356,13 +348,9 @@
 {
     NS_LOG_FUNCTION(this);
     Purge();
-    for (std::map<Ipv4Address, RoutingTableEntry>::iterator i = m_ipv4AddressEntry.begin();
-         i != m_ipv4AddressEntry.end();
-         ++i)
-    {
-        for (std::map<Ipv4Address, uint32_t>::const_iterator j = unreachable.begin();
-             j != unreachable.end();
-             ++j)
+    for (auto i = m_ipv4AddressEntry.begin(); i != m_ipv4AddressEntry.end(); ++i)
+    {
+        for (auto j = unreachable.begin(); j != unreachable.end(); ++j)
         {
             if ((i->first == j->first) && (i->second.GetFlag() == VALID))
             {
@@ -381,12 +369,11 @@
     {
         return;
     }
-    for (std::map<Ipv4Address, RoutingTableEntry>::iterator i = m_ipv4AddressEntry.begin();
-         i != m_ipv4AddressEntry.end();)
+    for (auto i = m_ipv4AddressEntry.begin(); i != m_ipv4AddressEntry.end();)
     {
         if (i->second.GetInterface() == iface)
         {
-            std::map<Ipv4Address, RoutingTableEntry>::iterator tmp = i;
+            auto tmp = i;
             ++i;
             m_ipv4AddressEntry.erase(tmp);
         }
@@ -405,14 +392,13 @@
     {
         return;
     }
-    for (std::map<Ipv4Address, RoutingTableEntry>::iterator i = m_ipv4AddressEntry.begin();
-         i != m_ipv4AddressEntry.end();)
+    for (auto i = m_ipv4AddressEntry.begin(); i != m_ipv4AddressEntry.end();)
     {
         if (i->second.GetLifeTime() < Seconds(0))
         {
             if (i->second.GetFlag() == INVALID)
             {
-                std::map<Ipv4Address, RoutingTableEntry>::iterator tmp = i;
+                auto tmp = i;
                 ++i;
                 m_ipv4AddressEntry.erase(tmp);
             }
@@ -442,13 +428,13 @@
     {
         return;
     }
-    for (std::map<Ipv4Address, RoutingTableEntry>::iterator i = table.begin(); i != table.end();)
+    for (auto i = table.begin(); i != table.end();)
     {
         if (i->second.GetLifeTime() < Seconds(0))
         {
             if (i->second.GetFlag() == INVALID)
             {
-                std::map<Ipv4Address, RoutingTableEntry>::iterator tmp = i;
+                auto tmp = i;
                 ++i;
                 table.erase(tmp);
             }
@@ -474,7 +460,7 @@
 RoutingTable::MarkLinkAsUnidirectional(Ipv4Address neighbor, Time blacklistTimeout)
 {
     NS_LOG_FUNCTION(this << neighbor << blacklistTimeout.As(Time::S));
-    std::map<Ipv4Address, RoutingTableEntry>::iterator i = m_ipv4AddressEntry.find(neighbor);
+    auto i = m_ipv4AddressEntry.find(neighbor);
     if (i == m_ipv4AddressEntry.end())
     {
         NS_LOG_LOGIC("Mark link unidirectional to  " << neighbor << " fails; not found");
@@ -505,9 +491,7 @@
     *os << std::setw(16) << "Flag";
     *os << std::setw(16) << "Expire";
     *os << "Hops" << std::endl;
-    for (std::map<Ipv4Address, RoutingTableEntry>::const_iterator i = table.begin();
-         i != table.end();
-         ++i)
+    for (auto i = table.begin(); i != table.end(); ++i)
     {
         i->second.Print(stream, unit);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/aodv/test/aodv-test-suite.cc ns-3.40/src/aodv/test/aodv-test-suite.cc
--- ns-3.39/src/aodv/test/aodv-test-suite.cc	2023-07-05 14:23:47.673426900 -0700
+++ ns-3.40/src/aodv/test/aodv-test-suite.cc	2023-09-27 13:30:37.614839000 -0700
@@ -317,11 +317,11 @@
         RerrHeader h;
         h.SetNoDelete(true);
         NS_TEST_EXPECT_MSG_EQ(h.GetNoDelete(), true, "trivial");
-        Ipv4Address dst = Ipv4Address("1.2.3.4");
+        Ipv4Address dst("1.2.3.4");
         NS_TEST_EXPECT_MSG_EQ(h.AddUnDestination(dst, 12), true, "trivial");
         NS_TEST_EXPECT_MSG_EQ(h.GetDestCount(), 1, "trivial");
         NS_TEST_EXPECT_MSG_EQ(h.AddUnDestination(dst, 13), true, "trivial");
-        Ipv4Address dst2 = Ipv4Address("4.3.2.1");
+        Ipv4Address dst2("4.3.2.1");
         NS_TEST_EXPECT_MSG_EQ(h.AddUnDestination(dst2, 12), true, "trivial");
         NS_TEST_EXPECT_MSG_EQ(h.GetDestCount(), 2, "trivial");
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/applications/helper/bulk-send-helper.cc ns-3.40/src/applications/helper/bulk-send-helper.cc
--- ns-3.39/src/applications/helper/bulk-send-helper.cc	2023-07-05 14:23:47.677426800 -0700
+++ ns-3.40/src/applications/helper/bulk-send-helper.cc	2023-09-27 13:30:37.614839000 -0700
@@ -59,7 +59,7 @@
 BulkSendHelper::Install(NodeContainer c) const
 {
     ApplicationContainer apps;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         apps.Add(InstallPriv(*i));
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/applications/helper/on-off-helper.cc ns-3.40/src/applications/helper/on-off-helper.cc
--- ns-3.39/src/applications/helper/on-off-helper.cc	2023-07-05 14:23:47.677426800 -0700
+++ ns-3.40/src/applications/helper/on-off-helper.cc	2023-09-27 13:30:37.614839000 -0700
@@ -60,7 +60,7 @@
 OnOffHelper::Install(NodeContainer c) const
 {
     ApplicationContainer apps;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         apps.Add(InstallPriv(*i));
     }
@@ -82,7 +82,7 @@
 {
     int64_t currentStream = stream;
     Ptr<Node> node;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         node = (*i);
         for (uint32_t j = 0; j < node->GetNApplications(); j++)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/applications/helper/packet-sink-helper.cc ns-3.40/src/applications/helper/packet-sink-helper.cc
--- ns-3.39/src/applications/helper/packet-sink-helper.cc	2023-07-05 14:23:47.677426800 -0700
+++ ns-3.40/src/applications/helper/packet-sink-helper.cc	2023-09-27 13:30:37.614839000 -0700
@@ -56,7 +56,7 @@
 PacketSinkHelper::Install(NodeContainer c) const
 {
     ApplicationContainer apps;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         apps.Add(InstallPriv(*i));
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/applications/helper/three-gpp-http-helper.cc ns-3.40/src/applications/helper/three-gpp-http-helper.cc
--- ns-3.39/src/applications/helper/three-gpp-http-helper.cc	2023-07-05 14:23:47.677426800 -0700
+++ ns-3.40/src/applications/helper/three-gpp-http-helper.cc	2023-09-27 13:30:37.614839000 -0700
@@ -61,7 +61,7 @@
 ThreeGppHttpClientHelper::Install(NodeContainer c) const
 {
     ApplicationContainer apps;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         apps.Add(InstallPriv(*i));
     }
@@ -109,7 +109,7 @@
 ThreeGppHttpServerHelper::Install(NodeContainer c) const
 {
     ApplicationContainer apps;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         apps.Add(InstallPriv(*i));
     }
